﻿@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using Portal.Controllers;
@using Portal.Models.SupplierPerformance;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.Credential;
@using Portal.Models.Globals;
@using Portal.Models.SupplierPerformance;

@Html.DevExpress().GridView(
    Grv => {
        Grv.Name = "GridSPShortageNonManufacturing";
        Grv.KeyFieldName = "PROD_MONTH; SUPPLIER_CD; PART_NO";
        Grv.CallbackRouteValues = new { Controller = "SupplierPerformance", Action = "ReloadGridShortageNonManufacturingDetail" };
        Grv.ClientSideEvents.BeginCallback = "OnBeginCallback";
        Grv.ClientSideEvents.EndCallback = "OnEndCallback";
        Grv.Width = Unit.Percentage(100);
        Grv.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.SettingsBehavior.AllowDragDrop = false;
        
        Grv.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
        //setting.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;

        Grv.SettingsEditing.Mode = GridViewEditingMode.Inline;
        
        Grv.SettingsPager.PageSizeItemSettings.Visible = true;
        Grv.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        Grv.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

        Grv.CommandColumn.Visible = true;
        Grv.CommandColumn.ClearFilterButton.Visible = true;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.Width = Unit.Pixel(42);
        Grv.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(
                        chckBox =>
                        {
                            chckBox.Name = "ChkBoxShortageNonManufacturing";
                            chckBox.Properties.ClientSideEvents.CheckedChanged = "OnCheckAll";
                        }
                    ).Render();
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "ProductionMonth";
                col.Caption = "Production<br>Month";
                col.FieldName = "PROD_MONTH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SPMonthYear> pm = Model.GetModel<List<SPMonthYear>>();
                if (pm.Count() > 0)
                    pm.ForEach(s => cmdSuppCode.Items.Add(s.MonthYear));  
            });

        Grv.Columns.Add(
            col => {
                col.Name = "SupplierCode";
                col.Caption = "Supplier<br>Code";
                col.FieldName = "SUPPLIER_CD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);
                                
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SupplierICS> Supplier = Model.GetModel<List<SupplierICS>>();
                if (Supplier.Count() > 0)
                    Supplier.ForEach(s => cmdSuppCode.Items.Add(s.SUPP_CD));  
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "SupplierName";
                col.Caption = "Supplier Name";
                col.FieldName = "SUPPLIER_NAME";
                col.Width = Unit.Pixel(180);
            });

        Grv.Columns.Add(
            col => {
                col.Name = "PartNo";
                col.Caption = "Part No";
                col.FieldName = "PART_NO";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col => {
                col.Name = "PartName";
                col.Caption = "Part Name";
                col.FieldName = "PART_NAME";
                col.Width = Unit.Pixel(180);
            });

        Grv.Columns.Add(
            col => {
                col.Name = "ShortageQty";
                col.Caption = "Shortage<br>Qty";
                col.FieldName = "SHORTAGE_QTY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });
        
         Grv.Columns.Add(
            col => {
                col.Name = "ReceivingArea";
                col.Caption = "Receiving<br>Area";
                col.FieldName = "RCV_AREA";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
                // add by alira.agi 2015-04-10 --combo box
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdDock = col.PropertiesEdit as ComboBoxProperties;
                cmdDock.DropDownStyle = DropDownStyle.DropDown;
                List<RcvArea> rcvarea = Model.GetModel<List<RcvArea>>();
                cmdDock.DataSource = rcvarea;
                cmdDock.TextFormatString = "{0}";
                cmdDock.ValueField = "RCV_AREA";
                cmdDock.Columns.Add("RCV_AREA", "Receiving Area", 100);
                cmdDock.Columns.Add("RCV_PLANT", "Plant Name", 100);
            });
        
        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedBy";
                col.Caption = "Created By";
                col.FieldName = "CREATED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedDate";
                col.Caption = "Created Date";
                col.FieldName = "CREATED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });
        
        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedBy";
                col.Caption = "ChangedBy";
                col.FieldName = "CHANGED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedDate";
                col.Caption = "Changed Date";
                col.FieldName = "CHANGED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });
        
        
        ///set value for call from javascript
        Grv.CustomJSProperties = (s, e) =>
        {
            MVCxGridView grid = (MVCxGridView)s;

            int StartIndex = 0;
            int EndIndex = Model.GetModel<List<SPShortage>>() != null ? Model.GetModel<List<SPShortage>>().Count :
                           Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);
           
            object[] ProductionMonth = new object[EndIndex - StartIndex];
            object[] SupplierCode = new object[EndIndex - StartIndex];
            object[] PartNo = new object[EndIndex - StartIndex];
            object[] ReceivingArea = new object[EndIndex - StartIndex];
            object[] ShortageQty = new object[EndIndex - StartIndex];

            for (int i = StartIndex; i < EndIndex; i++)
            {
                ProductionMonth[i - StartIndex] = grid.GetRowValues(i, "PROD_MONTH");
                SupplierCode[i - StartIndex] = grid.GetRowValues(i, "SUPPLIER_CD");
                PartNo[i - StartIndex] = grid.GetRowValues(i, "PART_NO");
                ShortageQty[i - StartIndex] = grid.GetRowValues(i, "SHORTAGE_QTY");
                ReceivingArea[i - StartIndex] = grid.GetRowValues(i, "RCV_AREA");
            }

            e.Properties["cpProductionMonth"] = ProductionMonth;
            e.Properties["cpSupplierCode"] = SupplierCode;
            e.Properties["cpPartNo"] = PartNo;
            e.Properties["cpShortageQty"] = ShortageQty;
            e.Properties["cpReceivingArea"] = ReceivingArea;

            grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        };
        
                
        ///set gridview when button on clicked
        Grv.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
        {
            string IsEditRow = Request.Params["IsEditRow"];
            MVCxGridView gv = (MVCxGridView)sender;

            ///set visibility filter row
            if (IsEditRow == "1" || IsEditRow == "2")
            {
                gv.Settings.ShowFilterRow = false;
                gv.Settings.ShowFilterRowMenu = false;
            }
            else
            {
                gv.Settings.ShowFilterRow = true;
                gv.Settings.ShowFilterRowMenu = true;
            }

            ///Disable checkbox when grid is editing
            if (e.ButtonType == ColumnCommandButtonType.SelectCheckbox)
            {
                if (IsEditRow == "1" || IsEditRow == "2")
                    e.Enabled = false;
            }

            ///hide default button update and cancel on gridview when row is editing
            if (e.ButtonType == ColumnCommandButtonType.Update)
                e.Visible = false;

            if (e.ButtonType == ColumnCommandButtonType.Cancel)
                e.Visible = false;
        };
        
        ///disabled keyfield when grid is editing
        Grv.CellEditorInitialize = (object sender, ASPxGridViewEditorEventArgs e) => {
            MVCxGridView gv = (MVCxGridView)sender;
            string IsEditRow = Request.Params["IsEditRow"];

            if (e.Column.FieldName == "PROD_MONTH")
            {   
                if(IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }   
            }

            if (e.Column.FieldName == "SUPPLIER_CD")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }

            if (e.Column.FieldName == "PART_NO")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }

            if (e.Column.FieldName == "RCV_AREA")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }   
            
            if (e.Column.FieldName == "SUPPLIER_NAME")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "PART_NAME")
            {
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            }

            if (e.Column.FieldName == "CREATED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
        };
    }).Bind(Model.GetModel<List<SPShortage>>()).GetHtml()